<?php

/**
 * The API Key and Application secret is generated by Facebook
 * when we create an application in Facebook.
 */
define("API_KEY", "63f06c85f8715fed9d738fb089669810");
define("SECRET",  "054f58f72a5edb4ac561e4d121ace953");

/**
 * Authentication/Authorization process
 *
 * 1. Call Auth.createToken to get a token from FB
 * 2. Generate a FB login url with which users enter their uname/pwd
 * 3. FB returns a session key once the user successfully both authenticates and authorizes One Social
 *    We will have to specify a call back url to which FB returns the session key via POST data
 * 4. Use this session key to make subsequent FB API calls
 */

$session_id = getSessionFromDB('testing', 2);
if ($session_id === false) {
	$auth = getAuthToken();
	showLoginUrl($auth); 
	exit;
}

if (isset($_GET['removeSessionFromDB']) && $_GET['removeSessionFromDB'] == 1) {
	removeSessionFromDB();
	print "Successfully deleted all entries in DB";
	exit;
}

if (isset($_GET['revokeUserAuth']) && $_GET['revokeUserAuth'] == 1) {
	removeUserAuth($session_id);
	exit;
}

$recentMsg = '';
if (!empty($_POST['status'])) {
	$recentMsg = $_POST['status'];
	setStatus($session_id, $_POST['status']);
}

getStream($session_id, $recentMsg);

// Function to get the list of all friends - Uncomment this when we are ready to display them
// getFriends($session_id);

exit;	

/**
 * Function that gets the friends info
 * of an authenticated user
 */
function getFriends($sessionKey) {
    $friendIds   = getFriendIDs($sessionKey);
    $friendNames = getFriendNames($friendIds, $sessionKey);
    
}

/**
 * Function that gets/displays all the friend names
 * give their uids
 */
function getFriendNames($friendIdsArray, $sessionKey) {

	// Limiting the number of friends to be displayed
	for ($i = 0; $i < 50; $i++) {
		$friendIdsNewArray[$i] = $friendIdsArray[$i];
	}
    $friendIds = implode(",", $friendIdsNewArray);
    $friendIds = '1000008406532';
    
    $time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.fql.query',
                    'query'       => "select name from user where uid IN ($friendIds)");
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_POSTFIELDS, "v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time&method=facebook.fql.query&query=select name from user where uid IN ($friendIds)");
    curl_setopt($ch, CURLOPT_POST, 1);
    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 200000);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);


    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    sort($friends);
    print "<b>Friends List:</b> <br><br>";
    foreach ($friends as $friend) {
        print $friend['name'] . "<br/>";
    }
}

/**
 * Function that gets all the friend ids
 * of an authenticated user
 */
function getFriendIDs($sessionKey) {

    $time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.friends.get');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 20000);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.friends.get&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time");
    curl_setopt($ch, CURLOPT_POST, 1);

    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    return $friends;
}


function getStream($sessionKey, $recentMsg) {

	startLayoutHTML();
	showStatusUpdateHTML();
	$time = microtime(true);
	$fql  = "SELECT post_id, actor_id, target_id, message, comments FROM stream WHERE source_id in (SELECT target_id FROM connection WHERE source_id=100001048604143) AND is_hidden = 0";
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.fql.query',
                    'query'       => $fql);
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_POSTFIELDS, "v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time&method=facebook.fql.query&query=$fql");
    curl_setopt($ch, CURLOPT_POST, 1);
    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 200000);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    $out = curl_exec($ch); 
    $stream = json_decode($out, true);
        
    print "<table align='center' width='800' height='100'><tr><td><h1>Latest Statuses</h1></td><td width='100'/><td></td></tr><tr><td>";
    print "<table border=0><tr><td>";
    print "<ul>";
    
    if ($recentMsg) {
    	print $recentMsg;
    	showCommentsUpdateHTML();
    }
    
    foreach ($stream as $msg) {
		$actorsData = getActorsData($sessionKey, getNumVal($msg['post_id']));
    	if (empty($actorsData[0]['pic_small'])) {
    		print "<img src='http://static.ak.fbcdn.net/pics/q_silhouette.gif'/>&nbsp;&nbsp;";
    	} else {
    		print "<img src='{$actorsData[0]['pic_small']}'/>&nbsp;&nbsp;";
    	}
    	print "<b>";
    	print $actorsData[0]['name'] . "</b> : " . $msg['message'];
    	print "<ul>";

    	foreach ($msg['comments']['comment_list'] as $comment) {
    		print "<li>" . $comment['text'] . "</li>";
    	}
    	print "</ul>";
     	showCommentsUpdateHTML();
    }
    print "</ul>";
    print "</td></tr></table></td><td width='100'/></table>";
    endLayoutHTML();
    print_r($stream);
    return $stream;
}

function setStatus($sessionKey, $status) {

	$time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
    				'status'      => $status,
                    'method'      => 'facebook.status.set');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 20000);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.status.set&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time&status=$status");
    curl_setopt($ch, CURLOPT_POST, 1);

    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    return $friends;
}



function getActorsData($sessionKey, $actorIDs) {

	$time = microtime(true);
	$fql  = "SELECT uid, name, pic_small FROM user WHERE uid IN ($actorIDs)";
	
	
	$params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.fql.query',
                    'query'       => $fql);
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_POSTFIELDS, "v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time&method=facebook.fql.query&query=$fql");
    curl_setopt($ch, CURLOPT_POST, 1);
    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 200000);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    $out    = curl_exec($ch); 
    $actors = json_decode($out, true);
	
    return $actors;
}

/**
 * Function that is used to generate
 * the login url
 */
function showLoginUrl($auth) {
    $params = array('api_key'                 => API_KEY,
                    'v'                       => '1.0',
                    'format'                  => 'json',
                    'auth_token'              => $auth,
                    'generate_session_secret' => 1,
                    'method'                  => 'facebook.auth.getSession');
    $sig = generateFBSignature($params, SECRET);

    print "<h3>View Your Facebook Activity from One Social</h3>";
    //print "<a href='http://www.facebook.com/login.php?v=1.0&return_session=1&extern=1&connect_display=page&req_perms=read_stream%2Cpublish_stream%2Coffline_access&api_key=" . API_KEY . "&auth_token=$auth&next=http%3A%2F%2Fonesocial.doesntexist.com%3A8000%2Fcallback.php%3Ffb%3D1&offline_access=1&required=1&return_session=1'><img border=0 src=\"http://wiki.developers.facebook.com/images/f/f5/Connect_white_large_long.gif\"></a><br/>";
    print "<a href='http://www.facebook.com/login.php?v=1.0&return_session=1&extern=1&connect_display=page&req_perms=read_stream%2Cpublish_stream%2Coffline_access%2Cstatus_update&api_key=" . API_KEY . "&auth_token=$auth&next=http%3A%2F%2Fonesocial.doesntexist.com%3A8000%2Fcallback.php%3Ffb%3D1&offline_access=1&required=1&return_session=1'><img border=0 src=\"http://wiki.developers.facebook.com/images/f/f5/Connect_white_large_long.gif\"></a><br/>";
}

 function getNumVal($val) {
 	$numVal = '';
 	$val    = (string)($val);
 	$size   = strlen($val);
 	for ($i = 0; $i < $size; $i++) {
 		if ($val[$i] == '_') {
 			return $numVal;
 		}
 		$numVal = $numVal . $val[$i];
 	}
 }

/**
 * This function is used to generate an auth token
 */
function getAuthToken() {
    $params = array('api_key' => API_KEY,
                    'v'       => '1.0',
                    'format'  => 'json',
                    'method'  => 'facebook.auth.createToken');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.auth.createToken&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig");
    curl_setopt($ch, CURLOPT_POST, 1);
    
    $out  = curl_exec($ch); 
    $auth = json_decode($out);
    curl_close($ch);

    return $auth;
}

function removeUserAuth($sessionKey) {

    $time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.auth.revokeAuthorization');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 20000);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.auth.revokeAuthorization&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time");
    curl_setopt($ch, CURLOPT_POST, 1);

    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    var_dump($friends);
    return $friends;
}

/**
 * This function is used to taken an array and a secret
 * and generate a md5 signature from it.
 */
function generateFBSignature($params, $secret) {

    // Sort the $params array by key
    ksort($params);

    $combined = '';
    foreach ($params as $key=>$value) {
        $combined .= $key.'='.$value;
    }
    $combined .= $secret;

    return md5($combined);
}

function getSessionFromDB($userID, $appID) {
	$session_id = false;
	mysql_connect('localhost', 'root', 'sowmya');
	
	$query   = "SELECT session_id FROM onesocial.sessions where user_id='$userID' and app_id=2";
	$result  = mysql_query($query);
	$numRows = mysql_numrows($result);
	
	for ($i = 0; $i < $numRows; $i++) {
		$session_id = mysql_result($result, $i, "session_id");
	}
	
	return $session_id;
}

function removeSessionFromDB() {
	mysql_connect('localhost', 'root', 'sowmya');
	
	$query   = "DELETE FROM onesocial.sessions";
	$result  = mysql_query($query);
}
function startLayoutHTML() {
    print "<html><head><title>One Social</title><link rel=stylesheet type='text/css' href='style.css'></head>";
    print "<body bottommargin='0' leftmargin='0' marginheight='0' marginwidth='0' rightmargin='0' topmargin='0' background='background.jpg' text='#EAF5FF'>";
    print "<table width='100%' height='94' cellpadding='0' cellspacing='0' border='0'>";
	print "<tr valign='top'><td width='246' height='94'><img src='templogo.jpg' width='246' height='94' border='0' alt=''></td>";
	print "<td width='368' height='94'><img src='topbar1.jpg' width='368' height='94' border='0' alt=''></td>";
	
	$html = <<<HTML
	<td width="100%" height="94" background="topbar1bg.jpg">&nbsp;</td>
	</tr>
	</table>
	<table width="100%" height="11" cellpadding="0" cellspacing="0" border="0">
		<tr valign="top">
			<td width="613" height="11"><img src="2maincolorarea.jpg" width="613" height="11" border="0" alt=""></td>
			<td width="100%" height="11" background="2maincolorarea_bg1.jpg">&nbsp;</td>
		</tr>
	</table>
	<table width="100%" height="33" cellpadding="0" cellspacing="0" border="0">
		<tr valign="top">
			<td width="246" height="33"><a href="http://onesocial.doesntexist.com:8000/">
			<img src="tempbuttons/button1.jpg" width="207" height="33" border="0" alt=""></a><BR>
			<a href="http://onesocial.doesntexist.com:8000/">
			<img src="friends.jpg" width="207" height="33" border="0" alt=""></a><BR>
			<a href="http://onesocial.doesntexist.com:8000/">
			<img src="tempbuttons/button2.jpg" width="207" height="33" border="0" alt=""></a><BR></td>
			<td width="368" height="33"><img src="3buttonarea.jpg" width="1100" height="33" border="0" alt=""></td>
		</tr>
	</table>
HTML;
    print $html;
}


function endLayoutHTML() {
   print "</body></html>";
}

function showCommentsUpdateHTML() {
	//print "<form action='http://onesocial.doesntexist.com:8000/facebook/FacebookAuth.php' method='POST'>";
    print "<table align='center' width='100' height='25'><tr><td>";
    print "<table border=0>";
    print "<textarea name=commentarea height=10 rows=1 cols=20></textarea>";
    print "</table></td></tr><tr><td align=right>";
    print "<input width = '100' height = '25' type=submit name=comment value='Comment'></td></tr></table>";
}

function showStatusUpdateHTML() {
	print "<form action='http://onesocial.doesntexist.com:8000/facebook/FacebookAuth.php' method='POST'>";
    print "<table align='center' width='650' height='100'><tr><td>";
    print "<table border=0>";
    print "<textarea name=status rows=2 cols=80></textarea>";
    print "</table></td></tr><tr><td align=right><input type=submit name=cmd value='Update Status'></td></tr></table>";
}

?>
