<?php

/**
 * The API Key and Application secret is generated by Facebook
 * when we create an application in Facebook.
 */
define("API_KEY", "63f06c85f8715fed9d738fb089669810");
define("SECRET",  "054f58f72a5edb4ac561e4d121ace953");

/**
 * Authentication/Authorization process
 *
 * 1. Call Auth.createToken to get a token from FB
 * 2. Generate a FB login url with which users enter their uname/pwd
 * 3. FB returns a session key once the user successfully both authenticates and authorizes One Social
 *    We will have to specify a call back url to which FB returns the session key via POST data
 * 4. Use this session key to make subsequent FB API calls
 */

$session_id = getSessionFromDB();
if ($session_id === false) {
	$auth = getAuthToken();
	showLoginUrl($auth); 
	exit;
}

if (isset($_GET['removeSessionFromDB']) && $_GET['removeSessionFromDB'] == 1) {
	removeSessionFromDB();
	print "Successfully deleted all entries in DB";
	exit;
}

if (isset($_GET['revokeUserAuth']) && $_GET['revokeUserAuth'] == 1) {
	removeUserAuth($session_id);
	exit;
}

getFriends($session_id);
exit;	

/**
 * Function that gets the friends info
 * of an authenticated user
 */
function getFriends($sessionKey) {
    $friendIds   = getFriendIDs($sessionKey);
    $friendNames = getFriendNames($friendIds, $sessionKey);
}

/**
 * Function that gets/displays all the friend names
 * give their uids
 */
function getFriendNames($friendIdsArray, $sessionKey) {

	// Limiting the number of friends to be displayed
	for ($i = 0; $i < 50; $i++) {
		$friendIdsNewArray[$i] = $friendIdsArray[$i];
	}
    $friendIds = implode(",", $friendIdsNewArray);
    
    $time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.fql.query',
                    'query'       => "select name from user where uid IN ($friendIds)");
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_POSTFIELDS, "v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time&method=facebook.fql.query&query=select name from user where uid IN ($friendIds)");
    curl_setopt($ch, CURLOPT_POST, 1);
    
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 200000);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);


    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    sort($friends);
    print "<b>Friends List:</b> <br><br>";
    foreach ($friends as $friend) {
        print $friend['name'] . "<br/>";
    }
}

/**
 * Function that gets all the friend ids
 * of an authenticated user
 */
function getFriendIDs($sessionKey) {

    $time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.friends.get');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 20000);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.friends.get&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time");
    curl_setopt($ch, CURLOPT_POST, 1);

    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    return $friends;
}

/**
 * Function that is used to generate
 * the login url
 */
function showLoginUrl($auth) {
    $params = array('api_key'                 => API_KEY,
                    'v'                       => '1.0',
                    'format'                  => 'json',
                    'auth_token'              => $auth,
                    'generate_session_secret' => 1,
                    'method'                  => 'facebook.auth.getSession');
    $sig = generateFBSignature($params, SECRET);

    print "<h3>View Your Facebook Activity from One Social</h3>";
    print "<a href='http://www.facebook.com/login.php?v=1.0&return_session=1&extern=1&connect_display=page&req_perms=read_stream%2Cpublish_stream%2Coffline_access&api_key=" . API_KEY . "&auth_token=$auth&next=http%3A%2F%2Fonesocial.doesntexist.com%3A8000%2Fcallback.php%3Ffb%3D1'><img border=0 src=\"http://wiki.developers.facebook.com/images/f/f5/Connect_white_large_long.gif\"></a><br/>";
}

/**
 * This function is used to generate an auth token
 */
function getAuthToken() {
    $params = array('api_key' => API_KEY,
                    'v'       => '1.0',
                    'format'  => 'json',
                    'method'  => 'facebook.auth.createToken');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.auth.createToken&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig");
    curl_setopt($ch, CURLOPT_POST, 1);
    
    $out  = curl_exec($ch); 
    $auth = json_decode($out);
    curl_close($ch);

    return $auth;
}

function removeUserAuth($sessionKey) {

    $time = microtime(true);
    $params = array('api_key'     => API_KEY,
                    'v'           => '1.0',
                    'call_id'     => $time,
                    'format'      => 'json',
                    'session_key' => $sessionKey,
                    'method'      => 'facebook.auth.revokeAuthorization');
    $sig = generateFBSignature($params, SECRET);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL,"http://api.facebook.com/restserver.php");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT_MS, 20000);
	curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);

    curl_setopt($ch, CURLOPT_POSTFIELDS, "method=facebook.auth.revokeAuthorization&v=1.0&api_key=" . API_KEY . "&format=json&sig=$sig&session_key=$sessionKey&call_id=$time");
    curl_setopt($ch, CURLOPT_POST, 1);

    $out = curl_exec($ch); 
    $friends = json_decode($out, true);
    var_dump($friends);
    return $friends;
}

/**
 * This function is used to taken an array and a secret
 * and generate a md5 signature from it.
 */
function generateFBSignature($params, $secret) {

    // Sort the $params array by key
    ksort($params);

    $combined = '';
    foreach ($params as $key=>$value) {
        $combined .= $key.'='.$value;
    }
    $combined .= $secret;

    return md5($combined);
}

function getSessionFromDB() {
	$session_id = false;
	mysql_connect('localhost', 'root', 'sowmya');
	
	$query   = "SELECT session_id FROM onesocial.sessions";
	$result  = mysql_query($query);
	$numRows = mysql_numrows($result);
	
	for ($i = 0; $i < $numRows; $i++) {
		$session_id = mysql_result($result, $i, "session_id");
	}
	
	return $session_id;
}

function removeSessionFromDB() {
	mysql_connect('localhost', 'root', 'sowmya');
	
	$query   = "DELETE FROM onesocial.sessions";
	$result  = mysql_query($query);
}

?>
