<?php

include_once('Masters Project/facebook/Facebook.php');
include_once('Masters Project/twitter/Twitter.php');
include_once('Masters Project/OneSocial.php');

$args = array();
if (isset($_GET['code'])) {
	$args['code'] = $_GET['code'];
} else if (isset($_GET['oauth_token'])) {
	$args['oauth_token'] = $_GET['oauth_token'];
}


$main = new Main($args);

if (isset($_GET['removeSessionFromDB']) && $_GET['removeSessionFromDB'] == 1) {
	$main->removeSessionFromDB();
	print "Successfully deleted all entries in DB";
	exit;
} else if (isset($_GET['logoff']) && $_GET['logoff'] == 1) {
	$main->removeAuthInCookie();
	header("Location: ./login.php");
	exit;
}

$main->start();
exit;


class Main {
	
	private $fb;
	private $tw;
	private $args;
	
	public function Main($args) {
		$this->args = $args;
		$this->fb 	= new Facebook();
		$this->tw 	= new Twitter();
	}
	
	public function start() {
		
		// Get the user id
		$userID = empty($_POST['userid'])? '' : $_POST['userid'];
		$pwd    = empty($_POST['pwd'])   ? '' : $_POST['pwd'];
		$format = empty($_GET['format']) ? '' : $_GET['format'];
		
		// Authenticate user
		if (empty($_POST['newuser'])) {
			if (empty($userID) || empty($pwd)) {
				$userID = $this->authenticateUserFromCookie();
			} else {
				$this->authenticateUserFromDB($userID, $pwd);	
			}
		} else {
			$fname = empty($_POST['fname'])? '' : $_POST['fname'];
			$lname = empty($_POST['lname'])? '' : $_POST['lname'];
			$this->createNewUser($userID, $pwd, $fname, $lname);
		}
		
		// Init FB and Twitter Session
		list ($fbSession, $twSession) = $this->getFBTWSession($userID);
		
		// Post a Facebook and Twitter Status
		$recentMsg = '';
		if (!empty($_POST['status'])) {
			$recentMsg = $_POST['status'];
			$this->fb->setUpdates($fbSession['secret'], $fbSession['token'], $recentMsg);
			$this->tw->setUpdates($twSession['secret'], $twSession['token'], $recentMsg);
			
			if ($format == 'xml') {
				$this->displayXMLSuccess();
				exit;
			}
		}
		
		// Post a Facebook Comment for a Status
		$recentComment = '';
		if (!empty($_POST['comment']) && !empty($_POST['statusID']) && !empty($_POST['app'])) {
			if ($_POST['app'] == Constants::FACEBOOK_APP_ID) {
				$this->fb->setComments($fbSession['secret'], $fbSession['token'], $_POST['comment'], $_POST['statusID']);
			} else {
				$this->tw->setComments($twSession['secret'], $twSession['token'], '@' . $_POST['com_user'] . ' ' . $_POST['comment'], $_POST['statusID']);
			}
			if ($format == 'xml') {
				$this->displayXMLSuccess();
				exit;
			}
		}

		// Get Facebook and Twitter Friends
		$fbFriends = $this->fb->getFriends($fbSession['secret'], $fbSession['token']);
		$twFriends = $this->tw->getFriends($twSession['secret'], $twSession['token']);
		
		if ($format != 'xml') {
			OneSocial::startLayoutHTML();
			OneSocial::friendsLayoutHTML(count($fbFriends), count($twFriends));
			OneSocial::showStatusUpdateHTML();
		}
		
		// FB Sessions expire all the time. Regenerate the session when it expires
		$fbUpdates = $this->fb->getUpdates($fbSession['secret'], $fbSession['token'], $recentMsg);
		if (false === $fbUpdates) {
			$this->fb->removeSessionFromDB($userID, Constants::FACEBOOK_APP_ID);
			header('Location: ./Main.php');
		}
		
		$twitterUpdates = $this->tw->getUpdates($twSession['secret'], $twSession['token'], $recentMsg);
		$bothUpdates = array_merge($fbUpdates, $twitterUpdates);
		
		OneSocial::displayUpdates($bothUpdates, $recentMsg, $format);
		
		if ($format != 'xml') {
			OneSocial::endLayoutHTML();
		}
	}
	
	function getFbFriends() {
		$fbFriends = Facebook:: getFriends($fbSession['secret'], $fbSession['token']);
		return $fbFriends;
	}
	
	function getTwFriends() {
		$twFriends = Twitter:: getFriends($twSession['secret'], $twSession['token']);
		return $twFriends;
	}
	
	
	private function displayXMLSuccess() {
		header('Content-type: application/xml');
		print "<?xml version='1.0'?>";
		print "<OneSocial><info>Message successfully updated</info></OneSocial>";
	}
	
	private function getFBTWSession($userID) {
		// Get Facebook Session
		$fbSession = $this->fb->getSession($userID, $this->args);
		if (empty($fbSession['secret']) && empty($fbSession['token'])) {
			$reqToken = $this->fb->getRequestToken(); 
			$this->fb->showLoginUrl($reqToken); 
			exit;
		}
		
		// Get Twitter Session
		$twSession = $this->tw->getSession($userID, $this->args);
		if (empty($twSession['secret']) && empty($twSession['token'])) {
			$reqToken = $this->tw->getRequestToken(); 
			$this->tw->showLoginUrl($reqToken); 
			exit;
		}
		
		return array ($fbSession, $twSession);
	}
	
	public function removeSessionFromDB() {
		mysql_connect('localhost', 'sowmya', 'sowmya');
		
		$query   = "DELETE FROM onesocial.sessions";
		$result  = mysql_query($query);
	}
	
	private function getAuthFromDB($userID) {
		mysql_connect('localhost', 'sowmya', 'sowmya');
		
		$query   = "SELECT pwd FROM onesocial.users where user_id='$userID'";
		$result  = mysql_query($query);
		$numRows = mysql_numrows($result);
		
		$auth = '';
		for ($i = 0; $i < $numRows; $i++) {
			$auth = mysql_result($result, $i, "pwd");
		}
		
		return $auth;
	}
	
	private function authenticateUserFromDB($userID, $pwd) {
		$auth = $this->getAuthFromDB($userID);
		if (md5($pwd) != $auth) {
			header("Location: ./login.php?loginerror=1");
			exit;
		}
		
		$this->setAuthIntoCookie($userID, $pwd);
	}
	
	public function removeAuthInCookie() {
		setcookie('onesocial', "");
	}
	
	private function setAuthIntoCookie($userID, $pwd) {
		setcookie('onesocial', $userID);
	}
	
	private function getAuthFromCookie() {
		$userID    = '';
		$cookieKey = 'onesocial';
		
		if (!empty($_COOKIE[$cookieKey])) {
			$userID = $_COOKIE[$cookieKey];
		}
		return $userID;
	}
	
	private function authenticateUserFromCookie() {
		$userID = $this->getAuthFromCookie();
		if (empty($userID)) {
			header("Location: ./login.php");
			exit;
		}
		return $userID;
	}
	
	private function createNewUser($userID, $pwd, $fname, $lname) {
		mysql_connect('localhost', 'sowmya', 'sowmya');
		
		$query   = "SELECT user_id FROM onesocial.users where user_id='$userID'";
		$result  = mysql_query($query);
		$numRows = mysql_numrows($result);
		
		if ($numRows) {
			header("Location: ./NewUser.php?createerror=1");
			exit;
		}
		
		$pwd     = md5($pwd);
		$query   = "INSERT INTO onesocial.users (user_id, pwd, fname, lname) values ('$userID', '$pwd', '$fname', '$lname')";
		$result  = mysql_query($query);
		
		$this->setAuthIntoCookie($userID, $pwd);
	}
}

?>