<?php

include_once('Masters Project/Constants.php');
include_once('Masters Project/OneSocial.php');

class Twitter extends OneSocial {
	
	const API_KEY   = "FtMIJIWXeTSHWKHXhQKwXg";
 	const SECRET    = "UybGDX9kZ4h1OSVKTdvtjcwlwfvn4TBCRvuUXiHC8";
	
 	public function getSession($user, $args) {
 		
 		$sessionData = parent::getSessionFromDB($user, Constants::TWITTER_APP_ID);
		if (!empty($sessionData['secret']) && !empty($sessionData['token'])) {
			return $sessionData;
		}
		
 		if (!empty($args['oauth_token'])) {
 			$auth 		  = $this->getAccessToken($args['oauth_token']);
			$authToken    = $auth['oauth_token'];
			$authSecret   = $auth['oauth_token_secret'];
			$this->insertSessionIntoDB($user, Constants::TWITTER_APP_ID, $authToken, $authSecret);
			return (array('token' => $authToken, 'secret' => $authSecret));
 		} else {
			return $sessionData;
 		}
 	}
	
	public  function getFriends($authSecret, $authToken) {
		$params = array('oauth_consumer_key'     => self::API_KEY,
	                    'oauth_token' 			 => $authToken,
	                    'oauth_signature_method' => 'HMAC-SHA1',
	                    'oauth_timestamp' 		 => time(),
	                    'oauth_nonce' 			 => md5(microtime() . mt_rand()));
	    
		$sigParams = $this->getSignedHeader("http://api.twitter.com/1/friends/ids.json", $params, array(), 'GET', $authSecret);
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL,"http://api.twitter.com/1/friends/ids.json");
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array($sigParams));
	    
	    $out  = curl_exec($ch);
	    $data = json_decode($out, true);
	    
	    return $data;
	    
	}	
	
	public  function addFriends() {
		
	}
	
	public  function validateSession() {
		
	}
	
	public function getUpdates($authSecret, $authToken, $recentMsg) {

		$params = array('oauth_consumer_key'     => self::API_KEY,
	                    'oauth_token' 			 => $authToken,
	                    'oauth_signature_method' => 'HMAC-SHA1',
	                    'oauth_timestamp' 		 => time(),
	                    'oauth_nonce' 			 => md5(microtime() . mt_rand()));
	    
		$sigParams = $this->getSignedHeader("http://api.twitter.com/1/statuses/home_timeline.json", $params, 
							array(), 'GET', $authSecret);
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL,"http://api.twitter.com/1/statuses/home_timeline.json");
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array($sigParams));
	    
	    $out = curl_exec($ch);
	
	    if(curl_errno($ch)) {
	        print 'Curl error: ' . curl_error($ch); exit;
	    }
	
	    $tweets  = array();
	    $updates = json_decode($out, true);
		foreach ($updates as $update) {
	    	$id = '' . $update['id_str']; 
			$tweets[$id] = $update;
		}
		
		$oneSocialResponse = array();

	    foreach ($tweets as $id => $tweet) {

	    	$oneResponse = array();
	    	if (isset($tweets['' . $tweet['in_reply_to_status_id_str']])) {
	    		continue;
	    	}
	    	
	    	$oneResponse['app']   = Constants::TWITTER_APP_ID;
	    	$oneResponse['user']  = $tweet['user']['screen_name'];
	    	$oneResponse['image'] = $tweet['user']['profile_image_url'];
	    	$oneResponse['text']  = $tweet['text'];
	    	$oneResponse['id']    = $tweet['id_str'];
	    	
	    	//print "Text: " . $tweet['text'] . ", ID: " . $tweet['id_str'] . ", Root: " . $tweet['in_reply_to_status_id_str'] . "<br/>";
	    	
	    	$time = $this->determineTimeAgo(strtotime($tweet['created_at']));
	    	$oneResponse['time'] = $time;
	    	
	    	$replies = array($id);
	    	$index   = 0;
	    	while (count($replies)) {
	    		$currentID = array_pop($replies);
	    		
		    	foreach ($tweets as $eachTweet) {
		    		if ($eachTweet['in_reply_to_status_id_str'] == $currentID) {
		    			array_push($replies, $eachTweet['id_str']);	    		
				    	
				    	$time = $this->determineTimeAgo(strtotime($eachTweet['created_at']));
				    	
				    	$oneResponse['message'][$index]['user']  = $eachTweet['user']['screen_name'];
				    	$oneResponse['message'][$index]['image'] = $eachTweet['user']['profile_image_url'];
				    	$oneResponse['message'][$index]['text']  = $eachTweet['text'];
				    	$oneResponse['message'][$index]['time']  = $time;
				    	$oneResponse['message'][$index]['app']   = Constants::TWITTER_APP_ID;
				    	$index++;
				    	
				    	//print "Text: " . $eachTweet['text'] . ", ID: " . $eachTweet['id_str'] . ", Root: " . $eachTweet['in_reply_to_status_id_str'] . "<br/>";
		    		}
		    	}
	    	}
		
	    	$oneSocialResponse[$oneResponse['time'][Constants::SECONDS] . 't'][] = $oneResponse;	    	
	    }
	    
	    return $oneSocialResponse;
	}
	
	public function setUpdates($authSecret, $authToken, $status) {

		$url    = "http://api.twitter.com/1/statuses/update.json";
	    $params = array('oauth_consumer_key'     => self::API_KEY,
	                    'oauth_token' 			 => $authToken,
	                    'oauth_signature_method' => 'HMAC-SHA1',
	                    'oauth_timestamp' 		 => time(),
	                    'oauth_nonce' 			 => md5(microtime() . mt_rand()));
	    $sigParams = $this->getSignedHeader($url, $params, array('status' => $status), 'POST', $authSecret);
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL, $url);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array($sigParams));
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_POSTFIELDS, "status=$status");
	    
	    $out = curl_exec($ch);
	    
	    if(curl_errno($ch)) {
	        print 'Curl error: ' . curl_error($ch); exit;
	    }
	
	    $tweets = json_decode($out, true);
	    //print_r($tweets);	
	}
	
	public function setComments($authSecret, $authToken, $status, $statusID) {
		$url    = "http://api.twitter.com/1/statuses/update.json";
	    $params = array('oauth_consumer_key'     => self::API_KEY,
	                    'oauth_token' 			 => $authToken,
	                    'oauth_signature_method' => 'HMAC-SHA1',
	                    'oauth_timestamp' 		 => time(),
	                    'oauth_nonce' 			 => md5(microtime() . mt_rand()));
	    $sigParams = $this->getSignedHeader($url, $params, array('status' => $status, 'in_reply_to_status_id' => $statusID), 'POST', $authSecret);
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL, $url);
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array($sigParams));
	    curl_setopt($ch, CURLOPT_POST, 1);
	    curl_setopt($ch, CURLOPT_POSTFIELDS, "status=$status&in_reply_to_status_id=$statusID");
	    
	    $out = curl_exec($ch);
	    if(curl_errno($ch)) {
	        print 'Curl error: ' . curl_error($ch); exit;
	    }
	
	    $tweets = json_decode($out, true);
	}
	
	public  function showLoginURL($auth) {
	    print "<h3>View Your Twitter Activity from One Social</h3>";
    	print "<a href='http://twitter.com/oauth/authorize?oauth_token={$auth}'><img border=0 src=\"http://apiwiki.twitter.com/f/1242697715/Sign-in-with-Twitter-darker.png\"></a><br/>";	
	}
	
	/**
	 * This function is used to generate an auth token
	 */
	public function getRequestToken() {
		
	    $params = array('oauth_consumer_key'     => self::API_KEY,
	                    'oauth_signature_method' => 'HMAC-SHA1',
	                    'oauth_nonce' 		     => md5(microtime() . mt_rand()),
	                    'oauth_timestamp' 		 => time());
	    $sigParams = $this->getSignedHeader("http://twitter.com/oauth/request_token", $params);
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL,"http://twitter.com/oauth/request_token");
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array($sigParams));
	    
	    $out = curl_exec($ch);
	
	    if(curl_errno($ch)) {
	        print 'Curl error: ' . curl_error($ch); exit;
	    }
	
	    parse_str($out, $auth);
	    return $auth['oauth_token'];
	}
	
	private function getSignedHeader($resourceURL, $oauth, $queryParams=array(), $httpMethod='GET', $oauthSecret='') {
	    $i = 0;
	    foreach (array($oauth, $queryParams) as $array) {
	        foreach ($array as $key => $value) {
	            $fieldsToSign[$key . ($i++)] = $key . '=' . rawurlencode($value);
	        }
	    }
	    
	    ksort ($fieldsToSign);
	    $strToSign = implode ('&', array(
	        $httpMethod,
	        urlencode($resourceURL),
	        urlencode(implode('&', $fieldsToSign))
	    ));
		
	    $consumerSecret = self::SECRET;
	    $secret = urlencode($consumerSecret) . '&';
	    if (false === empty($oauthSecret)) {
	        $secret .= urlencode($oauthSecret);
	    }
	    
	    $oauth['oauth_signature'] = base64_encode(hash_hmac('sha1', $strToSign, $secret, true));
	    foreach ($oauth as $key => $value) {
	        $fields[] = $key . '="' . urlencode($value) . '"';
	    }
	    return 'Authorization: OAuth ' . implode(", ", $fields);
	}
	
	public function getAccessToken($reqAuthToken) {
		
	    $params = array('oauth_consumer_key'     => self::API_KEY,
	                    'oauth_token' 			 => $reqAuthToken,
	                    'oauth_signature_method' => 'HMAC-SHA1',
	                    'oauth_nonce' 		     => md5(microtime() . mt_rand()),
	                    'oauth_timestamp' 		 => time());
	    $sigParams = $this->getSignedHeader("http://twitter.com/oauth/access_token", $params);
	
	    $ch = curl_init();
	    curl_setopt($ch, CURLOPT_URL,"http://twitter.com/oauth/access_token");
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch, CURLOPT_HTTPHEADER, array($sigParams));
	    
	    $out = curl_exec($ch);
	    if(curl_errno($ch)) {
	        print 'Curl error: ' . curl_error($ch); exit;
	    }
	
	    parse_str($out, $auth);
	    return $auth;
	}
}

?>